searchData={"items":[{"type":"module","title":"Flamel","doc":"Documentation for `Flamel`.","ref":"Flamel.html"},{"type":"function","title":"Flamel.blank?/1","doc":"Checks if something is blank?","ref":"Flamel.html#blank?/1"},{"type":"function","title":"Examples - Flamel.blank?/1","doc":"iex> Flamel.blank?(nil)\n    true\n\n    iex> Flamel.blank?(\"hello world\")\n    false\n\n    iex> Flamel.blank?(%{})\n    true\n\n    iex> Flamel.blank?(%{active: true})\n    false\n\n    iex> Flamel.blank?([])\n    true\n\n    iex> Flamel.blank?([\"one\"])\n    false\n\n    iex> Flamel.blank?(\"   \t   \")\n    true\n\n    iex> Flamel.blank?(0)\n    false\n\n    iex> Flamel.blank?(1)\n    false","ref":"Flamel.html#blank?/1-examples"},{"type":"function","title":"Flamel.boolean?/1","doc":"Is something a boolean?","ref":"Flamel.html#boolean?/1"},{"type":"function","title":"Examples - Flamel.boolean?/1","doc":"iex> Flamel.boolean?(true)\n    true\n\n    iex> Flamel.boolean?(false)\n    true\n\n    iex> Flamel.boolean?(nil)\n    false\n\n    iex> Flamel.boolean?(\"true\")\n    false","ref":"Flamel.html#boolean?/1-examples"},{"type":"function","title":"Flamel.present?/1","doc":"Checks if something is present?","ref":"Flamel.html#present?/1"},{"type":"function","title":"Examples - Flamel.present?/1","doc":"iex> Flamel.present?(nil)\n    false\n\n    iex> Flamel.present?(\"hello world\")\n    true\n\n    iex> Flamel.present?(%{})\n    false\n\n    iex> Flamel.present?(%{active: true})\n    true\n\n    iex> Flamel.present?([])\n    false\n\n    iex> Flamel.present?([\"one\"])\n    true\n\n    iex> Flamel.present?(\"   \t   \")\n    false\n\n    iex> Flamel.present?(0)\n    true\n\n    iex> Flamel.present?(1)\n    true","ref":"Flamel.html#present?/1-examples"},{"type":"function","title":"Flamel.to_atom/1","doc":"Converts to an atom. Warning: This uses `String.to_atom`","ref":"Flamel.html#to_atom/1"},{"type":"function","title":"Examples - Flamel.to_atom/1","doc":"iex> Flamel.to_atom(:test)\n    :test\n\n    iex> Flamel.to_atom(\"test\")\n    :test\n\n    iex> Flamel.to_atom(1)\n    :\"1\"\n\n    iex> Flamel.to_atom(1.1)\n    :\"1.1\"","ref":"Flamel.html#to_atom/1-examples"},{"type":"function","title":"Flamel.to_boolean/1","doc":"Convert something to a boolean","ref":"Flamel.html#to_boolean/1"},{"type":"function","title":"Examples - Flamel.to_boolean/1","doc":"iex> Flamel.to_boolean(\"Y\")\n    true\n\n    iex> Flamel.to_boolean(\"y\")\n    true\n\n    iex> Flamel.to_boolean(\"YES\")\n    true\n\n    iex> Flamel.to_boolean(\"Yes\")\n    true\n\n    iex> Flamel.to_boolean(\"yes\")\n    true\n\n    iex> Flamel.to_boolean(\"true\")\n    true\n\n    iex> Flamel.to_boolean(\"TRUE\")\n    true\n\n    iex> Flamel.to_boolean(1)\n    true\n\n    iex> Flamel.to_boolean(true)\n    true \n\n    iex> Flamel.to_boolean(\"N\")\n    false\n\n    iex> Flamel.to_boolean(\"n\")\n    false\n\n    iex> Flamel.to_boolean(\"NO\")\n    false\n\n    iex> Flamel.to_boolean(\"No\")\n    false\n\n    iex> Flamel.to_boolean(\"no\")\n    false\n\n    iex> Flamel.to_boolean(\"false\")\n    false\n\n    iex> Flamel.to_boolean(0)\n    false\n\n    iex> Flamel.to_boolean(false)\n    false","ref":"Flamel.html#to_boolean/1-examples"},{"type":"function","title":"Flamel.to_float/1","doc":"Converts to a float","ref":"Flamel.html#to_float/1"},{"type":"function","title":"Examples - Flamel.to_float/1","doc":"iex> Flamel.to_float(\"1.2\")\n    1.2\n\n    iex> Flamel.to_float(1.2)\n    1.2\n\n    iex> Flamel.to_float(1)\n    1.0\n\n    iex> Flamel.to_float(nil)\n    0.0","ref":"Flamel.html#to_float/1-examples"},{"type":"function","title":"Flamel.to_integer/1","doc":"Converts to an integer","ref":"Flamel.html#to_integer/1"},{"type":"function","title":"Examples - Flamel.to_integer/1","doc":"iex> Flamel.to_integer(\"1\")\n    1\n\n    iex> Flamel.to_integer(1)\n    1\n\n    iex> Flamel.to_integer(1.2)\n    1\n\n    iex> Flamel.to_integer(nil)\n    0","ref":"Flamel.html#to_integer/1-examples"},{"type":"function","title":"Flamel.to_map/1","doc":"Converts to a map","ref":"Flamel.html#to_map/1"},{"type":"function","title":"Flamel.to_string/1","doc":"Converts to a string","ref":"Flamel.html#to_string/1"},{"type":"function","title":"Examples - Flamel.to_string/1","doc":"iex> Flamel.to_string(nil)\n    \"\"\n\n    iex> Flamel.to_string(\"test\")\n    \"test\"\n\n    iex> Flamel.to_string(:test)\n    \"test\"\n\n    iex> Flamel.to_string(2.3)\n    \"2.3\"\n\n    iex> Flamel.to_string(1)\n    \"1\"\n\n    iex> Flamel.to_string(1)\n    \"1\"","ref":"Flamel.html#to_string/1-examples"},{"type":"function","title":"Flamel.try_and_return/2","doc":"Turn an exception into an error tuple. This can be used with `with` to\ncatch exceptions and turn them into error tuples.","ref":"Flamel.html#try_and_return/2"},{"type":"function","title":"Examples - Flamel.try_and_return/2","doc":"iex> Flamel.try_and_return(fn -> :ok end)\n    :ok\n\n    iex> Flamel.try_and_return(fn -> raise \"error\" end, {:ok, :default_value})\n    {:ok, :default_value}\n\n    iex> Flamel.try_and_return(fn -> raise \"error\" end)\n    {:error, \"error\"}","ref":"Flamel.html#try_and_return/2-examples"},{"type":"function","title":"Flamel.unwrap/1","doc":"Takes an {:ok, value} or {:error, message} tuple and returns the value","ref":"Flamel.html#unwrap/1"},{"type":"function","title":"Examples - Flamel.unwrap/1","doc":"iex> Flamel.unwrap({:ok, []})\n    []\n\n    iex> Flamel.unwrap({:error, \"message\"})\n    \"message\"","ref":"Flamel.html#unwrap/1-examples"},{"type":"function","title":"Flamel.unwrap_error!/1","doc":"Takes an {:ok, value} tuple and returns the value","ref":"Flamel.html#unwrap_error!/1"},{"type":"function","title":"Examples - Flamel.unwrap_error!/1","doc":"iex> Flamel.unwrap_error!({:ok, []})\n    ** (ArgumentError) {:ok, []} is not an :error tuple\n\n    iex> Flamel.unwrap_error!({:error, \"message\"})\n    \"message\"","ref":"Flamel.html#unwrap_error!/1-examples"},{"type":"function","title":"Flamel.unwrap_error_or_nil/1","doc":"Takes an {:error, value} tuple and returns the value or nil","ref":"Flamel.html#unwrap_error_or_nil/1"},{"type":"function","title":"Examples - Flamel.unwrap_error_or_nil/1","doc":"iex> Flamel.unwrap_error_or_nil({:ok, []})\n    nil\n\n    iex> Flamel.unwrap_error_or_nil({:error, \"message\"})\n    \"message\"","ref":"Flamel.html#unwrap_error_or_nil/1-examples"},{"type":"function","title":"Flamel.unwrap_ok!/1","doc":"Takes an {:ok, value} tuple and returns the value","ref":"Flamel.html#unwrap_ok!/1"},{"type":"function","title":"Examples - Flamel.unwrap_ok!/1","doc":"iex> Flamel.unwrap_ok!({:ok, []})\n    []\n\n    iex> Flamel.unwrap_ok!({:error, \"message\"})\n    ** (ArgumentError) {:error, \"message\"} is not an :ok tuple","ref":"Flamel.html#unwrap_ok!/1-examples"},{"type":"function","title":"Flamel.unwrap_ok_or_nil/1","doc":"Takes an {:ok, value} tuple and returns the value or nil","ref":"Flamel.html#unwrap_ok_or_nil/1"},{"type":"function","title":"Examples - Flamel.unwrap_ok_or_nil/1","doc":"iex> Flamel.unwrap_ok_or_nil({:ok, []})\n    []\n\n    iex> Flamel.unwrap_ok_or_nil({:error, \"message\"})\n    nil","ref":"Flamel.html#unwrap_ok_or_nil/1-examples"},{"type":"protocol","title":"Flamel.Atom","doc":"The `Flamel.Atom` protocol is responsible for\nconverting a structure to an Atom (only if applicable).","ref":"Flamel.Atom.html"},{"type":"function","title":"Flamel.Atom.to/1","doc":"Converts `term` to a Atom.","ref":"Flamel.Atom.html#to/1"},{"type":"type","title":"Flamel.Atom.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.Atom.html#t:t/0"},{"type":"protocol","title":"Flamel.Blank","doc":"The `Flamel.Blank` protocol is responsible for\ndetermining if something is blank","ref":"Flamel.Blank.html"},{"type":"function","title":"Flamel.Blank.blank?/1","doc":"Converts `term` to a Boolean","ref":"Flamel.Blank.html#blank?/1"},{"type":"type","title":"Flamel.Blank.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.Blank.html#t:t/0"},{"type":"protocol","title":"Flamel.Boolean","doc":"The `Flamel.Boolean` protocol is responsible for\nconverting a structure to an Boolean (only if applicable).","ref":"Flamel.Boolean.html"},{"type":"function","title":"Flamel.Boolean.to/1","doc":"Converts `term` to a Boolean.","ref":"Flamel.Boolean.html#to/1"},{"type":"type","title":"Flamel.Boolean.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.Boolean.html#t:t/0"},{"type":"module","title":"Flamel.Context","doc":"A Context can be used to in a pipeline to assign data to that future functions \ncan have access to and transform. It also includes a boolean value that \nsignals to other functions in the pipeline whether they should process the \ncontext or not.","ref":"Flamel.Context.html"},{"type":"module","title":"Example - Flamel.Context","doc":"```\nalias Flamel.Context\n\ncontext =\n  Context.new()\n  |> assign_user(user)\n  |> authorize()\n  |> perform_action()\n\nif context.assigns[:action_performed?] do\n  # something you are allowed to do\nend\n\ndef assign_user?(%Context{} = context, user) do\n  Context.assign(context, :user, user)\nend\n\ndef authorize(%Context{assigns: %{user: %{type: :admin}} = context) do\n  context\nend\n\ndef authorize(%Context{} = context) do\n  Context.halt!(context, \"Not permitted\")\nend\n\ndef perform_action(%Context{halt?: true}) do\n  # do nothing\n  context\nend\n\ndef perform_action(%Context{assigns: %{user: user}} = context) do\n  # Do something\n  Context.assign(context, %{action_performed_by: user, action_performed?: true})\nend\n```","ref":"Flamel.Context.html#module-example"},{"type":"function","title":"Flamel.Context.assign/2","doc":"If given a map it will merge values into the assigns in the context. It does not\nperform a deep merge.\n\nIf given a keyword list it will set values in the assigns. You can also push a value into the key if the value is a list.","ref":"Flamel.Context.html#assign/2"},{"type":"function","title":"Examples - Flamel.Context.assign/2","doc":"iex> context = Flamel.Context.assign(%Flamel.Context{}, %{hello: :world})\n    iex> context.assigns[:hello]\n    :world\n\n\n    iex> context = Flamel.Context.assign(%Flamel.Context{assigns: %{tags: []}}, set: [hello: :world], push: [tags: \"new\"])\n    iex> context.assigns[:hello]\n    :world\n    iex> context.assigns[:tags]\n    [\"new\"]","ref":"Flamel.Context.html#assign/2-examples"},{"type":"function","title":"Flamel.Context.assign/3","doc":"Assigns a value to a key in the context.\n\nThe assigns is meant to be used to store values in the context so that other functions in your pipeline can access them. The assigns storage is a map.","ref":"Flamel.Context.html#assign/3"},{"type":"function","title":"Examples - Flamel.Context.assign/3","doc":"iex> context = %Flamel.Context{}\n    iex> context.assigns[:hello]\n    nil\n    iex> context = Flamel.Context.assign(context, :hello, :world)\n    iex> context.assigns[:hello]\n    :world","ref":"Flamel.Context.html#assign/3-examples"},{"type":"function","title":"Flamel.Context.halt!/2","doc":"Signals to further functions in the pipeline that processing should stop","ref":"Flamel.Context.html#halt!/2"},{"type":"function","title":"Examples - Flamel.Context.halt!/2","doc":"iex> context = %Flamel.Context{}\n    iex> context.halt?\n    false\n    iex> context = Flamel.Context.halt!(context, \"no more\")\n    iex> context.halt?\n    true\n\n    iex> context = %Flamel.Context{}\n    iex> context.halt?\n    false\n    iex> context = Flamel.Context.halt!(context, \"some error message\")\n    iex> context.halt?\n    true\n    iex> context.reason\n    \"some error message\"","ref":"Flamel.Context.html#halt!/2-examples"},{"type":"function","title":"Flamel.Context.halted?/1","doc":"Has the context been halted?","ref":"Flamel.Context.html#halted?/1"},{"type":"function","title":"Examples - Flamel.Context.halted?/1","doc":"iex> context = Flamel.Context.halt!(%Flamel.Context{}, \"stop it\")\n    iex> Flamel.Context.halted?(context)\n    true","ref":"Flamel.Context.html#halted?/1-examples"},{"type":"function","title":"Flamel.Context.resume!/1","doc":"Signals to further functions in the pipeline that processing should resume","ref":"Flamel.Context.html#resume!/1"},{"type":"function","title":"Examples - Flamel.Context.resume!/1","doc":"iex> context = %Flamel.Context{halt?: true}\n    iex> context.halt?\n    true\n    iex> context = Flamel.Context.resume!(context)\n    iex> context.halt?\n    false","ref":"Flamel.Context.html#resume!/1-examples"},{"type":"type","title":"Flamel.Context.t/0","doc":"Flamel.Context","ref":"Flamel.Context.html#t:t/0"},{"type":"protocol","title":"Flamel.Contextable","doc":"The `Flamel.Contextable` protocol for working with something that \nstores a generic data structure and has the ability to.","ref":"Flamel.Contextable.html"},{"type":"function","title":"Flamel.Contextable.assign/2","doc":"Merges values in a map into the assigns in the context.","ref":"Flamel.Contextable.html#assign/2"},{"type":"function","title":"Flamel.Contextable.assign/3","doc":"Assigns a value to a key in the context.","ref":"Flamel.Contextable.html#assign/3"},{"type":"function","title":"Flamel.Contextable.halt!/2","doc":"Signals to further functions in the pipeline that processing should stop","ref":"Flamel.Contextable.html#halt!/2"},{"type":"function","title":"Flamel.Contextable.halted?/1","doc":"Has the context been halted?","ref":"Flamel.Contextable.html#halted?/1"},{"type":"function","title":"Flamel.Contextable.resume!/1","doc":"Signals to further functions in the pipeline that processing should resume","ref":"Flamel.Contextable.html#resume!/1"},{"type":"type","title":"Flamel.Contextable.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.Contextable.html#t:t/0"},{"type":"module","title":"Flamel.Contextable.Base","doc":"","ref":"Flamel.Contextable.Base.html"},{"type":"module","title":"Flamel.Ecto.Validators","doc":"Some validation functions for Ecto","ref":"Flamel.Ecto.Validators.html"},{"type":"function","title":"Flamel.Ecto.Validators.validate_at_least_one_required/3","doc":"A validate function that checks to see at least one of the fields is not blank","ref":"Flamel.Ecto.Validators.html#validate_at_least_one_required/3"},{"type":"function","title":"Example - Flamel.Ecto.Validators.validate_at_least_one_required/3","doc":"iex> Flamel.Ecto.Validators.validate_at_least_one_required(changeset, [:phone, :email], \"either phone or email is required\")","ref":"Flamel.Ecto.Validators.html#validate_at_least_one_required/3-example"},{"type":"protocol","title":"Flamel.Float","doc":"The `Flamel.Float` protocol is responsible for\nconverting a structure to an Float (only if applicable).","ref":"Flamel.Float.html"},{"type":"function","title":"Flamel.Float.to/1","doc":"Converts `term` to a Float.","ref":"Flamel.Float.html#to/1"},{"type":"type","title":"Flamel.Float.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.Float.html#t:t/0"},{"type":"protocol","title":"Flamel.Integer","doc":"The `Flamel.Integer` protocol is responsible for\nconverting a structure to an Integer (only if applicable).","ref":"Flamel.Integer.html"},{"type":"function","title":"Flamel.Integer.to/1","doc":"Converts `term` to a Integer.","ref":"Flamel.Integer.html#to/1"},{"type":"type","title":"Flamel.Integer.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.Integer.html#t:t/0"},{"type":"module","title":"Flamel.Map","doc":"A bunch of helper functions for Maps","ref":"Flamel.Map.html"},{"type":"function","title":"Flamel.Map.assign/2","doc":"","ref":"Flamel.Map.html#assign/2"},{"type":"function","title":"Flamel.Map.assign/3","doc":"Assign values in a map","ref":"Flamel.Map.html#assign/3"},{"type":"function","title":"Examples - Flamel.Map.assign/3","doc":"iex> map = Flamel.Map.assign(%{tags: []}, push: [tags: \"new\"])\n    iex> map[:tags] \n    iex> [\"new\"]\n\n    iex> map = Flamel.Map.assign(%{}, set: [name: \"Clark\"])\n    iex> map[:name] \n    iex> \"Clark\"\n\n    iex> map = Flamel.Map.assign(%{assigns: %{}}, :assigns, set: [name: \"Osa\"])\n    iex> get_in(map, [:assigns, :name])\n    iex> \"Osa\"\n\n    iex> map = Flamel.Map.assign(%{assigns: %{}}, :assigns, %{name: \"Clark\"})\n    iex> get_in(map, [:assigns, :name])\n    iex> \"Clark\"","ref":"Flamel.Map.html#assign/3-examples"},{"type":"function","title":"Flamel.Map.atomize_keys/1","doc":"Converts the top level keys in a map from string to atoms","ref":"Flamel.Map.html#atomize_keys/1"},{"type":"function","title":"Examples - Flamel.Map.atomize_keys/1","doc":"iex> Flamel.Map.atomize_keys(%{\"first_name\" => \"Thomas\", \"dob\" => \"07/01/1981\"})\n    %{first_name: \"Thomas\", dob: \"07/01/1981\"}\n\n    iex> Flamel.Map.atomize_keys(%{\"person\" => %{\"first_name\" => \"Thomas\", \"dob\" => \"07/01/1981\"}})\n    %{person: %{first_name: \"Thomas\", dob: \"07/01/1981\"}}\n\n    iex> Flamel.Map.atomize_keys(%{first_name: \"Thomas\", dob: \"07/01/1981\"})\n    %{first_name: \"Thomas\", dob: \"07/01/1981\"}","ref":"Flamel.Map.html#atomize_keys/1-examples"},{"type":"function","title":"Flamel.Map.stringify_keys/1","doc":"Converts the top level keys in a map from atoms to strings","ref":"Flamel.Map.html#stringify_keys/1"},{"type":"function","title":"Examples - Flamel.Map.stringify_keys/1","doc":"iex> Flamel.Map.stringify_keys(%{a: 1, b: 2})\n    %{\"a\" => 1, \"b\" => 2}\n\n    iex> Flamel.Map.stringify_keys(%{a: 1, b: 2, c: %{d: 3, e: 4}})\n    %{\"a\" => 1, \"b\" => 2, \"c\" => %{\"d\" => 3, \"e\" => 4}}\n\n    iex> Flamel.Map.stringify_keys(%{\"a\" => 1, \"b\" => 2})\n    %{\"a\" => 1, \"b\" => 2}","ref":"Flamel.Map.html#stringify_keys/1-examples"},{"type":"module","title":"Flamel.Map.Indifferent","doc":"","ref":"Flamel.Map.Indifferent.html"},{"type":"function","title":"Flamel.Map.Indifferent.get/3","doc":"Get a value from a map whether the key is a string or atom","ref":"Flamel.Map.Indifferent.html#get/3"},{"type":"function","title":"Examples - Flamel.Map.Indifferent.get/3","doc":"iex> Flamel.Map.Indifferent.get(%{test: \"value\"}, \"test\")\n    \"value\"\n\n    iex> Flamel.Map.Indifferent.get(%{test: \"value\"}, :test)\n    \"value\"\n\n    iex> Flamel.Map.Indifferent.get(%{\"test\" => \"value\"}, :test)\n    \"value\"\n\n    iex> Flamel.Map.Indifferent.get(%{\"test\" => \"value\"}, \"test\")\n    \"value\"\n\n    iex> Flamel.Map.Indifferent.get(%{\"test\" => \"value\"}, \"does-not-exist\", \"default\")\n    \"default\"","ref":"Flamel.Map.Indifferent.html#get/3-examples"},{"type":"module","title":"Flamel.Map.Safely","doc":"Helpers for working with maps safely. Don't use this all the time but\nsometimes you want to be as safe as possible.","ref":"Flamel.Map.Safely.html"},{"type":"function","title":"Flamel.Map.Safely.get/2","doc":"Safely get a value out of Map/Struct","ref":"Flamel.Map.Safely.html#get/2"},{"type":"function","title":"Flamel.Map.Safely.get/3","doc":"","ref":"Flamel.Map.Safely.html#get/3"},{"type":"protocol","title":"Flamel.Mappable","doc":"The `Flamel.Mappable` protocol is responsible for\nconverting a structure to an Map (only if applicable).","ref":"Flamel.Mappable.html"},{"type":"function","title":"Flamel.Mappable.to/1","doc":"Converts `term` to a Map.","ref":"Flamel.Mappable.html#to/1"},{"type":"type","title":"Flamel.Mappable.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.Mappable.html#t:t/0"},{"type":"protocol","title":"Flamel.Moment","doc":"The `Flamel.Moment` protocol is responsible for\nconverting a structure to a DateTime, Date, or ISO8601 string (only if applicable).","ref":"Flamel.Moment.html"},{"type":"function","title":"Flamel.Moment.to_date/1","doc":"Converts `term` to a Date","ref":"Flamel.Moment.html#to_date/1"},{"type":"function","title":"Flamel.Moment.to_datetime/1","doc":"Converts `term` to a DateTime.","ref":"Flamel.Moment.html#to_datetime/1"},{"type":"function","title":"Flamel.Moment.to_iso8601/1","doc":"Converts `term` to an ISO8601 string.","ref":"Flamel.Moment.html#to_iso8601/1"},{"type":"type","title":"Flamel.Moment.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.Moment.html#t:t/0"},{"type":"module","title":"Flamel.Retryable","doc":"Documentation for `Flamel.Retryable`.","ref":"Flamel.Retryable.html"},{"type":"function","title":"Flamel.Retryable.calc/1","doc":"Calculate a retry interval","ref":"Flamel.Retryable.html#calc/1"},{"type":"function","title":"Flamel.Retryable.exponential/1","doc":"Create an Exponential Retry Strategy","ref":"Flamel.Retryable.html#exponential/1"},{"type":"function","title":"Examples - Flamel.Retryable.exponential/1","doc":"iex> Flamel.Retryable.exponential(multiplier: 10)\n    %Flamel.Retryable.Exponential{multiplier: 10}","ref":"Flamel.Retryable.html#exponential/1-examples"},{"type":"function","title":"Flamel.Retryable.http/1","doc":"Create an HTTP Retry Strategy.\n\nThis strategy requires setting the HTTP status code so that\nit can adjust the retry interval based on the status.","ref":"Flamel.Retryable.html#http/1"},{"type":"function","title":"Examples - Flamel.Retryable.http/1","doc":"iex> Flamel.Retryable.http(max_attempts: 10)\n    %Flamel.Retryable.Http{max_attempts: 10}","ref":"Flamel.Retryable.html#http/1-examples"},{"type":"function","title":"Flamel.Retryable.linear/1","doc":"Create a Linear Retry Strategy","ref":"Flamel.Retryable.html#linear/1"},{"type":"function","title":"Examples - Flamel.Retryable.linear/1","doc":"iex> Flamel.Retryable.linear(max_attempts: 10)\n    %Flamel.Retryable.Linear{max_attempts: 10}","ref":"Flamel.Retryable.html#linear/1-examples"},{"type":"function","title":"Flamel.Retryable.try/2","doc":"Executes a function based on the `Flamel.Retryable.Strategy`. The function is\nexpected to return either a {:ok, result, strategy} or {:error, reason, strategy} tuple. If an error tuple is returned or an exception occurs the function will be retryed\nbased on the strategy configuration.","ref":"Flamel.Retryable.html#try/2"},{"type":"function","title":"Examples - Flamel.Retryable.try/2","doc":"iex> strategy = Flamel.Retryable.linear()\n    iex> Flamel.Retryable.try(strategy, fn strategy -> {:ok, \"success\", strategy} end)\n    iex> {:ok, \"success\", strategy}","ref":"Flamel.Retryable.html#try/2-examples"},{"type":"type","title":"Flamel.Retryable.interval/0","doc":"The number of milliseconds the next retry should happen in","ref":"Flamel.Retryable.html#t:interval/0"},{"type":"module","title":"Flamel.Retryable.Exponential","doc":"","ref":"Flamel.Retryable.Exponential.html"},{"type":"type","title":"Flamel.Retryable.Exponential.t/0","doc":"Exponential","ref":"Flamel.Retryable.Exponential.html#t:t/0"},{"type":"module","title":"Flamel.Retryable.Http","doc":"","ref":"Flamel.Retryable.Http.html"},{"type":"type","title":"Flamel.Retryable.Http.t/0","doc":"Http","ref":"Flamel.Retryable.Http.html#t:t/0"},{"type":"module","title":"Flamel.Retryable.Linear","doc":"","ref":"Flamel.Retryable.Linear.html"},{"type":"type","title":"Flamel.Retryable.Linear.t/0","doc":"Linear","ref":"Flamel.Retryable.Linear.html#t:t/0"},{"type":"protocol","title":"Flamel.Retryable.Strategy","doc":"The `Flamel.Retryable.Strategy` protocol calculates the retry interval \nto be used in situation that requires an action to be performed\nagain and at a different time because of a problem that occurred \npreviously while performing that action.","ref":"Flamel.Retryable.Strategy.html"},{"type":"function","title":"Flamel.Retryable.Strategy.calc/1","doc":"Calculate the next retry interval. It might also signal to stop retrying","ref":"Flamel.Retryable.Strategy.html#calc/1"},{"type":"type","title":"Flamel.Retryable.Strategy.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.Retryable.Strategy.html#t:t/0"},{"type":"module","title":"Flamel.Retryable.Strategy.Base","doc":"","ref":"Flamel.Retryable.Strategy.Base.html"},{"type":"protocol","title":"Flamel.String","doc":"The `Flamel.String` protocol is responsible for\nconverting a structure to an String (only if applicable).","ref":"Flamel.String.html"},{"type":"function","title":"Flamel.String.to/1","doc":"Converts `term` to a String","ref":"Flamel.String.html#to/1"},{"type":"type","title":"Flamel.String.t/0","doc":"All the types that implement this protocol.","ref":"Flamel.String.html#t:t/0"},{"type":"module","title":"Flamel.Struct","doc":"A bunch of helper functions for Structs","ref":"Flamel.Struct.html"},{"type":"function","title":"Flamel.Struct.fields/1","doc":"Return a list of fields from a strcut","ref":"Flamel.Struct.html#fields/1"},{"type":"function","title":"Examples - Flamel.Struct.fields/1","doc":"iex> Flamel.Struct.fields(%User{a: 1, b: 2})\n    [:a, :b]","ref":"Flamel.Struct.html#fields/1-examples"},{"type":"module","title":"Flamel.Task","doc":"","ref":"Flamel.Task.html"},{"type":"function","title":"Flamel.Task.delay/2","doc":"Execute a function after a specified delay interval.","ref":"Flamel.Task.html#delay/2"},{"type":"function","title":"Examples - Flamel.Task.delay/2","doc":"ie> task = Flamel.Task.delay(1_000, fn -> IO.puts(\"I am 1 second delayed\") end)\n    ie> Task.await(task)","ref":"Flamel.Task.html#delay/2-examples"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2023 Thomas Brewer\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Readme","doc":"# Flamel\n\n[![Elixir CI](https://github.com/themusicman/flamel/actions/workflows/elixir.yml/badge.svg)](https://github.com/themusicman/flamel/actions/workflows/elixir.yml)\n\nThis package is a bag of helper functions. Some might be questionable but they are what they are so use them as you will.","ref":"readme.html"},{"type":"extras","title":"Installation - Readme","doc":"If [available in Hex](https://hex.pm/packages/flamel), the package can be installed\nby adding `flamel` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:flamel, \"~> 1.3.0\"}\n  ]\nend\n```\nor mainline the latest:\n```elixir\ndef deps do\n  [\n    {:flamel, github: \"themusicman/flamel\", branch: \"main\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Examples - Readme","doc":"#","ref":"readme.html#examples"},{"type":"extras","title":"Context - Readme","doc":"Ability to create a context that can be used to build function pipelines\n\n```elixir\nalias Flamel.Context\n\ncontext =\n  %Context{}\n  |> assign_user(user)\n  |> authorize()\n  |> perform_action()\n\nif context.assigns[:action_performed?] do\n  # something you are allowed to do\nend\n\ndef assign_user?(%Context{} = context, user) do\n  Context.assign(context, :user, user)\nend\n\ndef authorize(%Context{assigns: %{user: %{type: :admin}} = context) do\n  context\nend\n\ndef authorize(%Context{} = context) do\n  Context.halt!(context, \"Not permitted\")\nend\n\ndef perform_action(%Context{halt?: true}) do\n  # do nothing\n  context\nend\n\ndef perform_action(%Context{assigns: %{user: user}} = context) do\n  # Do something\n  Context.assign(context, %{action_performed_by: user, action_performed?: true})\nend\n\n```\n\nYou don't have to use `%Flamel.Context{}` because `Flamel.Context` uses protocols. You can implement the `Flamel.Contextable` protocol for your own data type. Look at the interals of `Flamel.Retryable.Exponential` and `Flamel.Retryable.Linear` for an example. \n\n#","ref":"readme.html#context"},{"type":"extras","title":"Retryable (experimental) - Readme","doc":"Retryable functions that retry based on different strategies. Right now Linear and Exponential are the only 2 implemented but you can implement your own since the retry strategy uses two protocols (`Flamel.Contextable` and `Flamel.Retryable.Strategy`). \n\n```elixir\nstrategy = %Flamel.Retryable.Linear{} # or Flamel.Retryable.linear()\nFlamel.Retryable.try(strategy, fn strategy -> {:ok, \"success\", strategy} end)\n{:ok, \"success\", strategy}\n```\n\nYou can also assign values to the strategy since it implements `Flamel.Contextable`.\n\n```elixir\nstrategy = %Flamel.Retryable.Exponential{} # or Flamel.Retryable.exponential()\nimport Flamel.Context\n\nFlamel.Retryable.try(strategy, fn strategy ->\n  case make_http_request(url, payload) do\n    {:ok, result} ->\n      {:ok, result, strategy}\n\n    {:error, status, reason} ->\n      {:error, reason, assign(strategy, :http_status, status)}\n  end\nend)\n\n{:ok, \"success\", strategy}\n```\n\nThere is a `Flamel.Retryable.Http` strategy but it currently just implements the Exponential strategy. The intent is to \nchange the retry interval based on the HTTP status but this is not implemented yet. PRs are welcome. ;)\n\n#","ref":"readme.html#retryable-experimental"},{"type":"extras","title":"Delayed Task (experimental) - Readme","doc":"Executes an `Task.async` with a delay.\n\n```elixir\ntask =\n  Flamel.Task.delay(\n    interval_in_milliseconds,\n    fn ->\n      do_something()\n    end\n  )\n\nresult = Task.await(task)\n```\n\n\n#","ref":"readme.html#delayed-task-experimental"},{"type":"extras","title":"Utility - Readme","doc":"```elixir\nFlamel.try_and_return(fn -> :ok end) == :ok\n\nFlamel.try_and_return(fn -> raise \"error\" end, {:ok, :default_value}) == {:ok, :default_value}\n\nFlamel.unwrap_ok!({:ok, []}) == []\n\nFlamel.unwrap_ok_or_nil({:error, \"boom!\"}) == nil\n\n```\n\n#","ref":"readme.html#utility"},{"type":"extras","title":"Predicates - Readme","doc":"```elixir\nFlamel.blank?(%{}) == true\n\n# present is the opposite of blank?\nFlamel.present?(%{}) == false\n```\n\n#","ref":"readme.html#predicates"},{"type":"extras","title":"Conversions - Readme","doc":"```elixir\nFlamel.to_boolean(\"Y\") == true\n\nFlamel.to_integer(nil) == \"\"\n\nFlamel.to_integer(1) == 1\n\nFlamel.to_float(nil) == 0.0\n\nFlamel.to_float(1) == 1.0\n\nFlamel.to_string(nil) == \"\"\n```\n\n#","ref":"readme.html#conversions"},{"type":"extras","title":"DateTime - Readme","doc":"```elixir\nFlamel.Moment.to_datetime(\"2000-10-31T01:30:00.000-05:00\") == ~U[2000-10-31 06:30:00.000Z]\n\nFlamel.Moment.to_datetime(~N[2019-10-31 23:00:07]) == ~N[2019-10-31 23:00:07]\n\nFlamel.Moment.to_date(~D[2000-10-31]) == ~D[2000-10-31]\n\nFlamel.Moment.to_date(\"2000-10-31\") == ~D[2000-10-31]\n\nFlamel.Moment.to_iso8601(~U[2000-10-31 06:30:00.000Z]) == \"2000-10-31T06:30:00.000Z\"\n\nFlamel.Moment.to_iso8601(~D[2019-10-31]) == \"2019-10-31\"\n```\n\n#","ref":"readme.html#datetime"},{"type":"extras","title":"Maps/Structs - Readme","doc":"```elixir\nFlamel.Map.atomize_keys(%{\"first_name\" => \"Thomas\", \"dob\" => \"07/01/1981\"}) == %{first_name: \"Thomas\", dob: \"07/01/1981\"}\n\nmap =\n  Flamel.Map.assign(\n    %{assigns: %{hobbies: [\"playing\"]}},\n    :assigns,\n    set: [name: \"Osa\"],\n    push: [hobbies: [\"soccer\", \"coloring\"]]\n  )\n\nget_in(map, [:assigns, :hobbies]) == [\"soccer\", \"coloring\", \"playing\"]\nget_in(map, [:assigns, :name]) == \"Osa\"\n\nFlamel.Map.Indifferent.get(%{test: \"value\"}, \"test\") == \"value\"\n\nFlamel.Map.Indifferent.get(%{test: \"value\"}, :test) == \"value\"\n\nFlamel.Map.Safely.get(%Person{name: \"Todd\"}, &String.upcase(&1.name)) == \"TODD\"\n\nFlamel.Map.Safely.get(%{name: \"Todd\"}, &String.upcase(&1.bad_field), \"N/A\") == \"N/A\"\n```\n\nAll of the to_* functions are implemented using [Protocols](https://hexdocs.pm/elixir/1.16/protocols.html). So you can implement you own behavior for types that do not already have implementations.\n\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#maps-structs"}],"content_type":"text/markdown"}